import type { CSSProperties, MouseEventHandler } from 'react';
import React from 'react';
import type { ColorPickerBaseProps, ColorPickerProps } from '../interface';
export interface ColorTriggerProps extends Pick<ColorPickerBaseProps, 'prefixCls' | 'disabled' | 'format'> {
    color: NonNullable<ColorPickerBaseProps['color']>;
    open?: boolean;
    showText?: ColorPickerProps['showText'];
    className?: string;
    style?: CSSProperties;
    onClick?: MouseEventHandler<HTMLDivElement>;
    onMouseEnter?: MouseEventHandler<HTMLDivElement>;
    onMouseLeave?: MouseEventHandler<HTMLDivElement>;
}
declare const ColorTrigger: React.ForwardRefExoticComponent<ColorTriggerProps & React.RefAttributes<HTMLDivElement>>;
export default ColorTrigger;
