import * as React from 'react';
import type { GenerateConfig } from 'rc-picker/lib/generate/index';
import type { AnyObject } from '../../_util/type';
import type { GenericTimePickerProps, PickerProps, PickerPropsWithMultiple } from './interface';
export default function generatePicker<DateType extends AnyObject>(generateConfig: GenerateConfig<DateType>): {
    DatePicker: (<ValueType = DateType>(props: PickerPropsWithMultiple<DateType, PickerProps<DateType>, ValueType>) => React.ReactElement) & {
        displayName?: string | undefined;
    };
    WeekPicker: (<ValueType_1 = DateType>(props: PickerPropsWithMultiple<DateType, Omit<PickerProps<DateType>, "picker">, ValueType_1>) => React.ReactElement) & {
        displayName?: string | undefined;
    };
    MonthPicker: (<ValueType_1 = DateType>(props: PickerPropsWithMultiple<DateType, Omit<PickerProps<DateType>, "picker">, ValueType_1>) => React.ReactElement) & {
        displayName?: string | undefined;
    };
    YearPicker: (<ValueType_1 = DateType>(props: PickerPropsWithMultiple<DateType, Omit<PickerProps<DateType>, "picker">, ValueType_1>) => React.ReactElement) & {
        displayName?: string | undefined;
    };
    TimePicker: (<ValueType_2 = DateType>(props: PickerPropsWithMultiple<DateType, Omit<GenericTimePickerProps<DateType>, "picker">, ValueType_2>) => React.ReactElement) & {
        displayName?: string | undefined;
    };
    QuarterPicker: (<ValueType_1 = DateType>(props: PickerPropsWithMultiple<DateType, Omit<PickerProps<DateType>, "picker">, ValueType_1>) => React.ReactElement) & {
        displayName?: string | undefined;
    };
};
