/// <reference types="react" />
import type { Dayjs } from 'dayjs';
import generatePicker from './generatePicker';
import type { RangePickerProps as BaseRangePickerProps, PickerProps, PickerPropsWithMultiple } from './generatePicker/interface';
export type DatePickerProps<ValueType = Dayjs | Dayjs> = PickerPropsWithMultiple<Dayjs, PickerProps<Dayjs>, ValueType>;
export type MonthPickerProps<ValueType = Dayjs | Dayjs> = Omit<DatePickerProps<ValueType>, 'picker'>;
export type WeekPickerProps<ValueType = Dayjs | Dayjs> = Omit<DatePickerProps<ValueType>, 'picker'>;
export type RangePickerProps = BaseRangePickerProps<Dayjs>;
declare const DatePicker: (<ValueType = Dayjs>(props: PickerPropsWithMultiple<Dayjs, PickerProps<Dayjs>, ValueType>) => import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>) & {
    displayName?: string | undefined;
} & {
    displayName?: string | undefined;
    WeekPicker: (<ValueType_1 = Dayjs>(props: PickerPropsWithMultiple<Dayjs, Omit<PickerProps<Dayjs>, "picker">, ValueType_1>) => import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>) & {
        displayName?: string | undefined;
    };
    MonthPicker: (<ValueType_1 = Dayjs>(props: PickerPropsWithMultiple<Dayjs, Omit<PickerProps<Dayjs>, "picker">, ValueType_1>) => import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>) & {
        displayName?: string | undefined;
    };
    YearPicker: (<ValueType_1 = Dayjs>(props: PickerPropsWithMultiple<Dayjs, Omit<PickerProps<Dayjs>, "picker">, ValueType_1>) => import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>) & {
        displayName?: string | undefined;
    };
    RangePicker: import("react").ForwardRefExoticComponent<Omit<import("rc-picker").RangePickerProps<Dayjs>, "locale" | "generateConfig" | "hideHeader"> & {
        locale?: import("./generatePicker").PickerLocale | undefined;
        size?: import("../button").ButtonSize;
        placement?: "bottomLeft" | "bottomRight" | "topLeft" | "topRight" | undefined;
        bordered?: boolean | undefined;
        status?: "" | "warning" | "error" | undefined;
        variant?: "filled" | "outlined" | "borderless" | undefined;
        dropdownClassName?: string | undefined;
        popupClassName?: string | undefined;
        rootClassName?: string | undefined;
        popupStyle?: import("react").CSSProperties | undefined;
    } & import("react").RefAttributes<import("rc-picker").PickerRef>>;
    TimePicker: (<ValueType_2 = Dayjs>(props: PickerPropsWithMultiple<Dayjs, Omit<import("./generatePicker/interface").GenericTimePickerProps<Dayjs>, "picker">, ValueType_2>) => import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>) & {
        displayName?: string | undefined;
    };
    QuarterPicker: (<ValueType_1 = Dayjs>(props: PickerPropsWithMultiple<Dayjs, Omit<PickerProps<Dayjs>, "picker">, ValueType_1>) => import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>) & {
        displayName?: string | undefined;
    };
};
export type DatePickerType = typeof DatePicker & {
    _InternalPanelDoNotUseOrYouWillBeFired: typeof PurePanel;
    _InternalRangePanelDoNotUseOrYouWillBeFired: typeof PureRangePanel;
    generatePicker: typeof generatePicker;
};
declare const PurePanel: (props: import("../_util/type").AnyObject) => import("react").JSX.Element;
declare const PureRangePanel: (props: import("../_util/type").AnyObject) => import("react").JSX.Element;
declare const _default: DatePickerType;
export default _default;
